                include 'exec/types.i'
                include 'exec/libraries.i'
                include 'exec/semaphores.i'
                include 'dos/dos.i'

                include 'scan/ged.i'
                include 'scan/prefs.i'


MOD_VERSION	EQU	1
MOD_REVISION	EQU	0


*
* ModuleBase - This is the standard library node used by
*              external modules.  Image Scan will create
*              this structure when the module is opened.
*
*              The module should fill in the NumGads, NewGad,
*              Language, and LangCount fields before returning
*              from its custom Open function.
*

              STRUCTURE ModuleBase,LIB_SIZE
                UBYTE   mb_Flags
                UBYTE   mb_NumGads
                BPTR    mb_Segment
                APTR    mb_SysLib
                APTR    mb_ScanBase
                APTR    mb_NewGad
                STRUCT  mb_GContext,gedctxt_SIZEOF
                APTR    mb_Language
                APTR    mb_Text
                LONG    mb_LangCount
                APTR    mb_CmdTable
                ULONG   mb_PrefID
                ULONG   mb_PrefLen
                STRUCT  mb_Reserved,4*14
                LABEL   modbase_SIZEOF
                ; 64 bytes reserved here...
                STRUCT  mb_Private,64
                LABEL   xmodbase_SIZEOF

MB_VISIBLE	EQU	0
MB_TEXTLOADED	EQU	1

*
* ScanBase - The library base maintained by Image Scan.  Hook programs
*            will open this library to gain access to Image Scan functions,
*            while modules will be passed a pointer directly to this
*            base for accessing the same functions.  These fields should
*            be considered READ ONLY, excepted where noted otherwise.
*

              STRUCTURE ScanBase,LIB_SIZE
                APTR    sb_pScreen
                APTR    sb_pWindow
                APTR    sb_pRPort
                STRUCT  sb_Prefs,prefs_SIZEOF
                APTR    sb_IntuitionBase
                APTR    sb_GfxBase
                ULONG   sb_LastError
                APTR    sb_MainBuffer
                APTR    sb_SwapBuffer
                APTR    sb_Text
                STRUCT  sb_Lock,SS_SIZE
                APTR    sb_Alpha
                ;
                ; New for Mirage 0.53:
                ;
                BYTE    sb_AreaTool
                BYTE    sb_DrawTool
                UBYTE   sb_Channel
                BYTE    sb_GuiLocked

                BYTE    sb_ArexxCmd
                BYTE    sb_Iconified

                BYTE    sb_FillType
                BYTE    sb_FillRange1
                BYTE    sb_FillRange2
                BYTE    sb_FillSmooth
                BYTE    sb_FillSkew
                BYTE    sb_FillRough
                WORD    sb_FloodClose
                BYTE    sb_LightTab
                BYTE    sb_AlphaMask

                BYTE    sb_EdgeMode
                UBYTE   sb_EdgeDir
                WORD    sb_EdgeRadius

                BYTE    sb_Hidden
                BYTE    sb_TranspRange
                WORD    sb_TranspClose

                BYTE    sb_AirRadius
                BYTE    sb_DrawMode
                BYTE    sb_DrawBlend
                BYTE    sb_Mode

                WORD    sb_GridX
                WORD    sb_GridY
                WORD    sb_GOffsetX
                WORD    sb_GOffsetY

                APTR    sb_Brush

                APTR    sb_Scanner
                APTR    sb_Render
                APTR    sb_Printer

                APTR    sb_PubName
                APTR    sb_ArexxName

                APTR    sb_CurrentDir
                APTR    sb_ThisTask

                BYTE    sb_DrawAlpha
                BYTE    sb_AirDensity
                BYTE    sb_AirSmear
                BYTE    sb_BackPen

                APTR    sb_Shanghai

                BYTE    sb_PenType
                BYTE    sb_PenSize
                BYTE    sb_AlphaTab
                BYTE    sb_AirRough

                APTR    sb_HookMsg

                APTR    sb_vScreen

                APTR    sb_HelpLock

                APTR    sb_HostPort

                ULONG   sb_Magic

                APTR    sb_TextLock

                WORD    sb_PantoDX
                WORD    sb_PantoDY
                WORD    sb_PantoCX
                WORD    sb_PantoCY

                APTR    sb_PenArray
                WORD    sb_PenWidth
                WORD    sb_PenHeight

                APTR    sb_AirArray
                WORD    sb_AirWidth
                WORD    sb_AirHeight

                UBYTE   sb_Exclusive
                STRUCT  sb_pad3,3

                STRUCT  sb_LearnOpts,64

                ; New for 2.0

                STRUCT  sb_BufList,MLH_SIZE

                ULONG   sb_NewFlags
                APTR    sb_EnvDir

                APTR    sb_EWindow
                APTR    sb_MWindow
                APTR    sb_PWindow

                APTR    sb_EGSIntuiBase
                APTR    sb_EGSGfxBase
                APTR    sb_EScreen

                STRUCT  sb_BrushList,MLH_SIZE

                UBYTE   sb_Include
                UBYTE   sb_Exclude
                UBYTE   sb_TClose
                UBYTE   sb_pad4

                LABEL   scanbase_SIZEOF


