/*
 * ImageFX Development Header File
 * Copyright  1991-1995 Nova Design, Inc.
 * Written by Thomas Krehbiel
 *
 * Main Module Include File.
 *
 */

#ifndef SCAN_MOD_H
#include <scan/mod.h>
#endif
#ifndef SCAN_BUF_H
#include <scan/buf.h>
#endif
#ifndef SCAN_ERRORS_H
#include <scan/errors.h>
#endif
#ifndef SCAN_PROTOS_H
#include <scan/scan_protos.h>
#endif
#ifndef SCAN_PRAGMAS_H
#include <scan/pragmas.h>
#endif

extern struct DosLibrary     *DOSBase;    /* changed to concur with proto/dos.h */
extern struct ExecBase       *SysBase;
extern struct IntuitionBase  *IntuitionBase;
extern struct GfxBase        *GfxBase;

extern struct ModuleBase     *ModuleBase;
extern struct ScanBase       *ScanBase;

extern ULONG                  LibOpen(void);
extern ULONG                  LibClose(void);
extern ULONG                  LibExpunge(void);
extern ULONG                  LibNull(void);

extern char                  *GetStr(int idx, char *def);

#define Alloc(a,b)            AllocMem(a,b)
#define Free(a,b)             FreeMem(a,b)


/*
 * These are the coordinates of the "action" area.
 */
#define ACTION_LEFT           (11)
#define ACTION_TOP            (14)
#define ACTION_RIGHT          (ACTION_LEFT + 417 - 1)
#define ACTION_BOTTOM         (ACTION_TOP + 62 - 1)

