/*
 * ImageFX Development Header File
 * Copyright  1991-1995 Nova Design, Inc.
 * Written by Thomas Krehbiel
 *
 * Resolution Presets (2.0).
 *
 */

#ifndef EXEC_NODES_H
#include <exec/nodes.h>
#endif

/*
 * Preset:
 *
 * This structure is returned by the new scan.library function
 * NewGetPreset().  It should be considered READ ONLY.
 *
 */
struct Preset
{
   struct MinNode Node;
   short          Width;
   short          Height;
   short          AspectX;
   short          AspectY;
   short          DPIX;
   short          DPIY;
   char           Label[64];
   LONG           reserved[8];
};

/*
 * Flags for NewGetPreset():
 */
#define PRESET_SIZE     (0x01)
#define PRESET_ASPECT   (0x02)
#define PRESET_DPI      (0x04)
#define PRESET_ALL      (PRESET_SIZE | PRESET_ASPECT | PRESET_DPI)

